<template>
  <div class="chat-input-container">
    <p
      class="required-toll not-enough-toll"
      v-if="!isFriend && notEnoughCoin"
    >Not Enough coin to pay toll</p>
    <p class="required-toll" v-else-if="!isFriend">Required Toll: {{ requiredToll }} coin</p>
    <input
      type="text"
      placeholder="Type your message"
      v-model="message"
      class="chat-input"
      v-on:keyup.enter="submitMessage"
      :disabled="notEnoughCoin"
    />
  </div>
</template>

<script>
import utils from "../assets/utils";
import { mapGetters } from "vuex";
export default {
  props: ["friend", "isFriend", "setPendingMessage"],
  data: function() {
    return {
      message: "",
      requiredToll: null
    };
  },
  computed: {
    ...mapGetters({
      getWallet: "wallet/getWallet",
      getAppState: "chat/getAppState"
    }),
    notEnoughCoin() {
      if (this.getAppState.data.balance < parseFloat(this.requiredToll))
        return true;
      return false;
    }
  },
  methods: {
    async submitMessage() {
      let messageToSend = this.message;
      this.message = "";
      let myWallet = this.getWallet;
      let isSubmitted = await utils.sendMessage(
        messageToSend,
        myWallet,
        this.friend
      );
      this.setPendingMessage({
        handle: this.getWallet.handle,
        timestamp: null,
        body: messageToSend
      });
    }
  },
  async mounted() {
    const targetAddress = await utils.getAddress(this.friend);
    this.requiredToll = await utils.getToll(
      targetAddress,
      this.getWallet.entry.address
    );
  }
};
</script>

<style>
.chat-input-container {
  height: 70px;
  background: #f2f2f2;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  width: 100%;
  position: fixed;
  top: calc(100% - 70px);
  z-index: 100;
}
.chat-input {
  height: 40px;
  width: 90%;
  max-width: 600px;
  padding: 5px 10px;
  background: #fff;
  border: 1px solid #dddddd;
  border-radius: 5px;
}
.chat-input-container .required-toll {
  text-align: left;
  width: 90%;
  margin-bottom: 5px;
  padding-left: 5px;
  color: #d79341;
  max-width: 600px;
}
.chat-input-container .required-toll.not-enough-toll {
  color: red;
}
input[type='text'],
input[type='number'],
textarea {
  font-size: 16px !important;
}
</style>
